const extractAccessToken = (scriptToParse) => {
    const arr = scriptToParse.match(/<script.*>window.location.href="(?<path>.*)";<\/script>/);
    const facebookReturnUrl = arr?.groups?.path;
    const urlParams = new URLSearchParams(facebookReturnUrl);
    return urlParams.get('access_token');
}

const checkPageAndSendMessage = () => {
    const currentUrl = window.location.href;
    const isInstagramLogin = currentUrl.includes("accounts/login/");
    const isExactPostInstagramLogin = currentUrl === "https://www.instagram.com/";
    const isSubmit = currentUrl.includes("submit/");

    if (isSubmit) {
        const headContent = document.getElementsByTagName('head')[0].innerHTML;
        const accessToken = extractAccessToken(headContent);
        if (accessToken) {
            chrome.runtime.sendMessage({
                type: 'EASYLIVE_FACEBOOK_RCV_TOKEN',
                token: accessToken,
            });
        }
    }

    if (isExactPostInstagramLogin) {
        chrome.runtime.sendMessage({
            type: 'EASYLIVE_INSTAGRAM_RCV_TOKEN',
            isInstagramLogin: isInstagramLogin,
            isPostInstagramLogin: isExactPostInstagramLogin,
        });
    }
}

if (document.readyState === "complete" || document.readyState === "interactive") {
    checkPageAndSendMessage();
} else {
    document.addEventListener("DOMContentLoaded", checkPageAndSendMessage);
}